package cofh.thermal.expansion.block.entity.machine;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import cofh.core.util.helpers.ItemHelper;
import cofh.lib.api.StorageGroup;
import cofh.lib.client.sounds.ConditionalSoundInstance;
import cofh.lib.inventory.ItemStorageCoFH;
import cofh.thermal.core.config.ThermalCoreConfig;
import cofh.thermal.core.util.managers.machine.FurnaceRecipeManager;
import cofh.thermal.expansion.init.TExpSounds;
import cofh.thermal.expansion.init.TExpTileEntities;
import cofh.thermal.expansion.inventory.container.machine.MachineFurnaceContainer;
import cofh.thermal.lib.block.entity.MachineBlockEntity;
import cofh.thermal.lib.util.recipes.IMachineInventory;
import cofh.thermal.lib.util.recipes.IThermalInventory;
import javax.annotation.Nullable;
import net.minecraft.core.BlockPos;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.sounds.SoundSource;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockState;

public class MachineFurnaceTile extends MachineBlockEntity {
  protected ItemStorageCoFH inputSlot;
  
  protected ItemStorageCoFH outputSlot;
  
  public MachineFurnaceTile(BlockPos pos, BlockState state) {
    super((BlockEntityType)TExpTileEntities.MACHINE_FURNACE_TILE.get(), pos, state);
    this.inputSlot = new ItemStorageCoFH(item -> (this.filter.valid(item) && FurnaceRecipeManager.instance().validRecipe(item)));
    this.outputSlot = new ItemStorageCoFH();
    this.inventory.addSlot(this.inputSlot, StorageGroup.INPUT);
    this.inventory.addSlot(this.outputSlot, StorageGroup.OUTPUT);
    this.inventory.addSlot(this.chargeSlot, StorageGroup.INTERNAL);
    addAugmentSlots(ThermalCoreConfig.machineAugments);
    initHandlers();
  }
  
  protected int getBaseProcessTick() {
    return FurnaceRecipeManager.instance().getBasePower();
  }
  
  protected boolean cacheRecipe() {
    this.curRecipe = FurnaceRecipeManager.instance().getRecipe((IThermalInventory)this);
    if (this.curRecipe != null)
      this.itemInputCounts = this.curRecipe.getInputItemCounts((IMachineInventory)this); 
    return (this.curRecipe != null);
  }
  
  @Nullable
  public AbstractContainerMenu m_7208_(int i, Inventory inventory, Player player) {
    return (AbstractContainerMenu)new MachineFurnaceContainer(i, this.f_58857_, this.f_58858_, inventory, player);
  }
  
  protected Object getSound() {
    return new ConditionalSoundInstance((SoundEvent)TExpSounds.SOUND_MACHINE_FURNACE.get(), SoundSource.AMBIENT, (BlockEntity)this, () -> Boolean.valueOf((!this.f_58859_ && this.isActive)));
  }
  
  protected boolean validateInputs() {
    if (!cacheRecipe())
      return false; 
    return (this.inputSlot.getCount() >= ((Integer)this.itemInputCounts.get(0)).intValue());
  }
  
  protected boolean validateOutputs() {
    if (this.curRecipe == null && !cacheRecipe())
      return false; 
    ItemStack output = this.outputSlot.getItemStack();
    if (output.m_41619_())
      return true; 
    ItemStack recipeOutput = this.curRecipe.getOutputItems((IMachineInventory)this).get(0);
    if (output.m_41613_() >= output.m_41741_())
      return false; 
    return ItemHelper.itemsEqualWithTags(output, recipeOutput);
  }
}
